<%--
 Copyright (C) 2003-2005 Funambol
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 --%>

<%-- author: Stefano Nichele @ Funambol --%>
<%-- $Id: addDevice.jsp,v 1.3 2005/05/23 08:03:21 nichele Exp $ --%>

<%@ taglib prefix="sql" uri="/WEB-INF/tlds/sql.tld" %>
<%@ taglib prefix="c" uri="/WEB-INF/tlds/c.tld" %>
<%@ taglib prefix="fmt" uri="/WEB-INF/tlds/fmt.tld" %>

<%@ page import="java.util.*" %>
<%@ page import="java.sql.*" %>
<%@ page import="javax.sql.*" %>
<%@ page import="sync4j.framework.tools.*" %>
<%@ page import="sync4j.dmdemo.*" %>

<%@ page errorPage = "ErrorPage.jsp" %>

<jsp:useBean id="dmDemoBean" scope="session" class="sync4j.dmdemo.DMDemoBean"/>

<%
   // Set the datasource in session
   session.setAttribute("dataSource", dmDemoBean.getDataSource());

   String loginAccess    = request.getParameter("login");
   String passwordAccess = request.getParameter("pwd");

   String name     = request.getParameter("name");
   String company  = request.getParameter("company");
   String job      = request.getParameter("job");
   String address  = request.getParameter("address");
   String city     = request.getParameter("city");
   String zip      = request.getParameter("zip");
   String state    = request.getParameter("state");
   String country  = request.getParameter("country");
   String email    = request.getParameter("email");
   String phone    = request.getParameter("phone");
   String deviceId = request.getParameter("deviceId");

   String reg      = request.getParameter("reg");

   boolean userAlreadyRegistered = false;

   if (reg != null && reg.equalsIgnoreCase("true")) {

       userAlreadyRegistered = dmDemoBean.checkIfUserAlreadyExists(deviceId);

       if (!userAlreadyRegistered) {
           dmDemoBean.registerNewUser(name,
           company,
           job,
           address,
           city,
           zip,
           state,
           country,
           email,
           phone,
           deviceId
           );
       }
   }

%>

<c:set var="reg"><%= reg %></c:set>
<c:set var="userAlreadyRegistered"><%= userAlreadyRegistered %></c:set>


<html>
    <head>
        <title>Sync4j DM Demo</title>
        <link rel="stylesheet" type="text/css" href="../css/style.css">

        <script language="JavaScript1.2">
            function createNewUser() {
            //showProp(document.documentElement, 'document.documentElement');
              document.location.href = 'addDevice.jsp';
           }

           function checkValue() {
               var deviceId = document.forms.reg.deviceId.value;

               if (deviceId == null || deviceId == '') {

                   alert("Device Id is required");
                   return false;
               }

               return true;
           }
        </script>
    </head>

    <body>

        <div align="center"><a target="_top" href="http://sync4j.funambol.com" border="0"><img src="../img/sync4j.gif" alt="Sync4j Server DM" border="0"></a><br></div>
        <div align="center" style=" font-size:14;font-family:arial;font.style:bold">Server DM</div>

        <c:choose>
            <c:when test="${userAlreadyRegistered=='true'}">
                <br />
                <br />
                <div align="center" class="loginError">Device already registered.</div>
                <br />
                <div align="center"><input type="button" name="back" value="Create New Device" onClick="createNewUser()"/></div>
            </c:when>

            <c:otherwise>

                <c:choose>
                    <c:when test="${reg=='true'}">
                        <br />
                        <br />
                        <div align="center" class="loginError">Device created.</div>
                        <br />
                        <div align="center"><input type="button" name="back" value="Create New Device" onClick="createNewUser()"/></div>
                    </c:when>

                    <c:otherwise>
                        <br />
                        <div align="center" >
                            <form action="addDevice.jsp" name="reg" onSubmit="return checkValue()" >
                                <input type="hidden" name="reg" value="true" />
                                <input type="hidden" name="login" value="<%= loginAccess %>" />
                                <input type="hidden" name="pwd" value="<%= passwordAccess %>" />
                                <input type="hidden" name="name" value=" " />
                                <input type="hidden" name="email" value=" " />

                                        <table width="1%" border="0" bordercolor="red">
                                            <tr>
                                                <td colspan="2">&nbsp;</td>
                                            </tr>
                                            <tr>
                                                <td nowrap="nowrap">Device Id :</td>
                                                <td><input type="text" name="deviceId"/></td>
                                            </tr>
                                            <tr>
                                                <td align="center" colspan="2"><input type="submit"  name="regUser" value="Add" /></td>
                                            </tr>

                                        </table>
                            </form>
                        </div>
                    </c:otherwise>
                </c:choose>


            </c:otherwise>


        </c:choose>


    </body>

</html>


