<%--
 Copyright (C) 2003-2005 Funambol
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 --%>

<%-- author: Stefano Nichele @ Funambol --%>
<%-- $Id: genericSession.jsp,v 1.1 2005/05/16 17:00:37 nichele Exp $ --%>

<%@ taglib prefix="sql" uri="/WEB-INF/tlds/sql.tld" %>
<%@ taglib prefix="c" uri="/WEB-INF/tlds/c.tld" %>
<%@ taglib prefix="fmt" uri="/WEB-INF/tlds/fmt.tld" %>

<%@ page import="java.io.*" %>
<%@ page import="java.util.*" %>
<%@ page import="java.beans.*" %>

<%@ page import="org.apache.taglibs.standard.tag.common.sql.ResultImpl" %>

<%@ page import="sync4j.framework.engine.dm.*" %>
<%@ page import="sync4j.framework.core.*" %>

<%@ page errorPage = "ErrorPage.jsp" %>

<fmt:setLocale value="en_EN" />
<fmt:setBundle basename="DMDemo" />

<jsp:useBean id="dmDemoBean" scope="session" class="sync4j.dmdemo.DMDemoBean"/>

<%
    // Set the datasource in session
    session.setAttribute("dataSource", dmDemoBean.getDataSource());

    String newSession  = request.getParameter("newSession");
    String clone       = request.getParameter("clone");

    String deviceId    = request.getParameter("deviceId");
    String sessionId   = request.getParameter("sessionId");
    String operationId = request.getParameter("operationId");
    String deleteOp    = request.getParameter("deleteOp");
    String save        = request.getParameter("save");

    String move    = request.getParameter("move");
    String refresh = request.getParameter("refresh");

    // Parameters to create new operation
    String addOp         = request.getParameter("addOp");
    String operationName = request.getParameter("operationName");
    String nodeUri       = request.getParameter("nodeUri");
    String objectValue   = request.getParameter("objectValue");
    String newNode       = request.getParameter("newNode");

    String preconfiguredOperations = request.getParameter("preconfiguredOperations");

    if (deviceId != null) {
        dmDemoBean.setDeviceId(deviceId);
    } else {
        deviceId = dmDemoBean.getDeviceId();
    }

    if (newSession != null && newSession.equalsIgnoreCase("true")) {
        dmDemoBean.startNewManagementSession(deviceId, sync4j.dmdemo.DMDemoBean.PROCESSOR_GENERIC);
        deviceId  = dmDemoBean.getDeviceId();
        if (preconfiguredOperations != null && !preconfiguredOperations.equals("")) {
            dmDemoBean.genericProcessorTools.setPreconfiguredOperations(preconfiguredOperations);
            dmDemoBean.saveSession();

        %>
            <jsp:forward page="main.jsp" />
        <%
        }

    }

    if (save != null && save.equalsIgnoreCase("true")) {
        dmDemoBean.saveSession();
         %>
            <jsp:forward page="main.jsp" />
        <%
    }

    if (refresh != null && refresh.equalsIgnoreCase("true")) {
        if (sessionId != null && !sessionId.equals("")) {
            dmDemoBean.setSessionId(sessionId);
        } else {
            sessionId = dmDemoBean.getSessionId();
        }
        dmDemoBean.loadSession(sessionId);
    }

    sessionId = dmDemoBean.getSessionId();

    String stateDescription = dmDemoBean.getStateDescription();

    if (move != null && !move.equals("")) {
        int index = Integer.parseInt(operationId);
        if (move.equalsIgnoreCase("up")) {
            dmDemoBean.genericProcessorTools.moveOperationUp(index);
        } else {
            dmDemoBean.genericProcessorTools.moveOperationDown(index);
        }
    }

    if (deleteOp != null && deleteOp.equals("true")) {
        int index = -1;
        if (operationId != null) {
            index = Integer.parseInt(operationId);
        }
        dmDemoBean.genericProcessorTools.removeOperation(index);
    }

    // checks for new operations
    if (addOp != null && addOp.equals("true")) {

        if (newNode != null && newNode.equalsIgnoreCase("true")) {
            dmDemoBean.genericProcessorTools.addManagementOperation(operationName, nodeUri, objectValue, true);
        } else {
            dmDemoBean.genericProcessorTools.addManagementOperation(operationName, nodeUri, objectValue, false);
        }
    }

%>

<%-- Checks "Clone" request --%>
<c:set var="clone"><%= clone %></c:set>

<c:if test="${clone == 'true'}">
    <%
        //dmDemoBean.cloneSession();
        //sessionId = dmDemoBean.getSessionId();
    %>
</c:if>
<c:set var="state"><%= dmDemoBean.getSessionState() %></c:set>

<html>
<head>
<title><fmt:message key="WINDOW_TITLE" /></title>
<link rel="stylesheet" type="text/css" href="../css/style.css" />
</head>

<script language="JavaScript1.2">
    function onChangeOperation(value) {
        if (value == "Get" || value == "Delete" ) {

            document.getElementById("100").disabled = false;
            document.getElementById("101").disabled = false;
            document.getElementById("102").disabled = false;
            document.getElementById("200").disabled = true;
            document.getElementById("201").disabled = true;
            document.getElementById("400").disabled = true;

        } else if (value == "Add" || value == "Replace") {

            document.getElementById("100").disabled = false;
            document.getElementById("101").disabled = false;
            document.getElementById("102").disabled = false;
            document.getElementById("200").disabled = false;
            document.getElementById("201").disabled = false;
            document.getElementById("400").disabled = false;

        } else if (value == 'ShowAlertMessage' || value == 'ShowConfirmMessage') {

            document.getElementById("100").disabled = true;
            document.getElementById("101").disabled = true;
            document.getElementById("102").disabled = true;
            document.getElementById("200").disabled = false;
            document.getElementById("201").disabled = false;
            document.getElementById("400").disabled = true;

        } else {

            document.getElementById("100").disabled = true;
            document.getElementById("101").disabled = true;
            document.getElementById("102").disabled = true;
            document.getElementById("200").disabled = true;
            document.getElementById("201").disabled = true;
            document.getElementById("400").disabled = true;

        }
    }

    function onChangeObject(value) {
        if (value != 'other') {
            document.operations.nodeUri.value = value;
        } else {
            document.operations.nodeUri.value = '';
        }
    }

    function checkNewNode(value) {
        if (value.checked) {
            document.getElementById("200").disabled = true;
            document.getElementById("201").disabled = true;
        } else {
            document.getElementById("200").disabled = false;
            document.getElementById("201").disabled = false;
        }
    }

    function refreshList() {
        location.href = 'genericSession.jsp?deviceId=<%= deviceId%>&refresh=true';
    }

    function saveSession() {
        var currentDeviceId = -1;
        if (document.getElementById("300") != null) {
            currentDeviceId = document.getElementById("300").value;
        } else {
            currentDeviceId = '<%= deviceId %>';
        }
        location.href='genericSession.jsp?save=true&deviceId=' + currentDeviceId;
    }

    function addOperation() {

        if (document.operations.nodeUri == '') {
            alert('<fmt:message key="INSERT_THE_NODE_URI" />');
            return ;
        }


        var currentDeviceId = -1;
        if (document.getElementById("300") != null) {
            currentDeviceId = document.getElementById("300").value;
        } else {
            currentDeviceId = '<%= deviceId %>';
        }
        document.forms.operations.deviceId.value = currentDeviceId;
        document.forms.operations.submit();
    }

    function showProp(obj, title) {
        var result = "";
        var cont = 0;
        for (var i in obj) {
            cont++;
            result += title + " - " +  i + " = " + obj[i] + "\n";
            if (cont==10) {
                alert(result);
                cont=0;
                result="";
            }
        }
        alert(result);
    }

    function goBack() {
        //showProp(document.documentElement, 'document.documentElement');
        document.location.href = 'main.jsp';
    }
</script>
</head>

<body>
    <form name="operations" method="get" action="genericSession.jsp">
        <input type="hidden" name="addOp" value="true" />
        <input type="hidden" name="deviceId" value="<%=deviceId%>" />
        <input type="hidden" name="sessionId" value="<%= sessionId%>" />
        <input type="hidden" name="state" value='<c:out value="${state}"/>' />

    <table width="100%" border="0" bordercolor="blue">
        <tr>
            <td align="center">
                <table cellpadding="2" cellspacing="0">
                    <tr>
                        <td><fmt:message key="DEVICE_ID" />:</td>
                        <td><%= deviceId%></td>
                    </tr>
                     <tr>
                        <td><fmt:message key="SESSION_ID" />:</td><td><%= sessionId%></td>
                    </tr>
                    <tr>
                        <td><fmt:message key="STATE" />:</td>
                        <td>
                            <c:if test="${state == 'P'}">
                                <fmt:message key="STATE_TO_PROCESS" />
                            </c:if>
                            <c:if test="${state == 'C'}">
                                <fmt:message key="STATE_COMPLETED" />
                            </c:if>
                            <c:if test="${state == 'N'}">
                                <fmt:message key="STATE_NOTIFIED" />
                            </c:if>
                            <c:if test="${state == 'E'}">
                                <fmt:message key="ERROR" />
                            </c:if>
                            <c:if test="${state == 'A'}">
                                <fmt:message key="ABORTED" />
                            </c:if>
                        </td>
                    </tr>
                    <tr>
                        <td><fmt:message key="OPERATION" />:</td><td><fmt:message key="CUSTOM_PROCESSOR" /></td>
                    </tr>

                </table>
            </td>
        </tr>


        <c:if test="${state == 'P'}">
            <tr>
                <td align="center">
                    <table>
                    <tr>
                    <td align="center">
                    <div style="border: 1px solid gray;" align="center">
                    <table border="0" bordercolor="green" cellpadding="5" cellspacing="0">
                        <tr>
                            <td><fmt:message key="NEW_OPERATION" />:</td>
                            <td >
                                <select name="operationName" ONCHANGE="onChangeOperation(this.value)">
                                    <option value="Add">Add</option>
                                    <option value="Delete">Delete</option>
                                    <option value="Get">Get</option>
                                    <option value="Replace">Replace</option>
                                    <option value="ShowAlertMessage"><fmt:message key="ALERT_DISPLAY" /></option>
                                    <option value="ShowConfirmMessage"><fmt:message key="ALERT_CONFIRMATION" /></option>
                                </select>
                            </td>
                            <td style="visibility:visible">
                                <input id="400" type="checkbox" onClick="checkNewNode(this)" name="newNode" value="true" />
                                <fmt:message key="NEW_NODE" />
                            </td>
                            <td></td>
                        </tr>
                        <tr>
                            <td id="100" style="visibility:visible"><fmt:message key="NODE_URI" />: </td>
                            <td colspan="2" style="visibility:visible" width="1">
                                <select id="101" name="objectName" ONCHANGE="onChangeObject(this.value)">
                                    <option value="other"><fmt:message key="OTHER_NODE_URI" /></option>
                                    <option value="./DevDetail">./DevDetail</option>
                                    <option value="./DevDetail/LrgObj">./DevDetail/LrgObj</option>
                                    <option value="./DevDetail/HwV">./DevDetail/HwV</option>
                                    <option value="./DevDetail/SwV">./DevDetail/SwV</option>
                                    <option value="./DevDetail/FwV">./DevDetail/FwV</option>
                                    <option value="./DevDetail/OEM">./DevDetail/OEM</option>
                                    <option value="./DevDetail/DevTyp">./DevDetail/DevTyp</option>
                                    <option value="./DevDetail/URI">./DevDetail/URI</option>
                                    <option value="./DevDetail/URI/MaxSegLen">./DevDetail/URI/MaxSegLen</option>
                                    <option value="./DevDetail/URI/MaxTotLen">./DevDetail/URI/MaxTotLen</option>
                                    <option value="./DevDetail/URI/MaxDepth">./DevDetail/URI/MaxDepth</option>
                                    <option value="./DevDetail/Bearer">./DevDetail/Bearer</option>
                                    <option value="./DevInfo">./DevInfo</option>
                                    <option value="./DevInfo/Lang">./DevInfo/Lang</option>
                                    <option value="./DevInfo/DmV">./DevInfo/DmV</option>
                                    <option value="./DevInfo/Mod">./DevInfo/Mod</option>
                                    <option value="./DevInfo/Man">./DevInfo/Man</option>
                                    <option value="./DevInfo/DevId">./DevInfo/DevId</option>
                                    <option value="./SyncML">./SyncML</option>
                                    <option value="./SyncML/Con">./SyncML/Con</option>
                                    <option value="./SyncML/DMAcc">./SyncML/DMAcc</option>
                                </select>
                            </td>
                            <td style="visibility:visible">
                                <input id="102" type="textfield" size="30" name="nodeUri" />
                            </td>
                         </tr>
                         <tr>
                            <td id="200" style="visibility:visible"><fmt:message key="VALUE" />:</td>
                            <td  colspan="3"  style="visibility:visible"><input id="201" type="text" size="30" name="objectValue" /></td>
                        </tr>
                         <tr>
                            <td align="center" colspan="4"><input type="button" name="add" value="<fmt:message key="ADD_TO_CUSTOM_OPERATIONS" />" onclick="addOperation()"/></td>
                        </tr>
                    </table>
                    </div>
                    </td>
                    </tr>
                    </table>
                </td>
            </tr>
        </c:if>

        <tr><td><hr/></td></tr>
        <tr>
            <td align="center">
                <table cellpadding="10" cellspacing="0" border="0">
                    <tr>
                        <c:if test="${state == 'P'}">
                            <td><input type="button" name="save" value="<fmt:message key="ADD_TO_OPERATION_LIST" />" onclick="saveSession()" /></td>
                        </c:if>
                        <td><input type="button" name="back" value="<fmt:message key="CANCEL" />" onclick="goBack()" /></td>
                        <%--c:if test="${clone != 'true'}">
                           <td><input type="button" name="clone"  value="Clone"  onclick="location.href='genericSession.jsp?clone=true'" /></td>
                        </c:if--%>
                    </tr>
                </table>
            </td>
        </tr>
        <tr>
            <td align="center">
                <table>
                    <tr>
                        <td><fmt:message key="OPERATIONS_LIST" /></td>
                    </tr>
                </table>
            </td>
        </tr>
        <tr>
            <td align="center">
                <table cellpadding="5" cellspacing="0" border="1">
                    <tr>
                        <th><fmt:message key="OPERATION" /></th>
                        <th><fmt:message key="NODE_URI" /></th>
                        <th><fmt:message key="VALUE" /></th>
                        <c:choose>
                            <c:when test="${state == 'P'}">
                                <th>&nbsp;</th>
                                <th>&nbsp;</th>
                            </c:when>
                            <c:otherwise>
                                <th><fmt:message key="RESULTS" /></th>
                                <th><fmt:message key="STATUS_CODE" /></th>
                            </c:otherwise>
                        </c:choose>
                    </tr>
                    <%
                        ManagementOperation operation = null;
                        ManagementOperationResult operationResult = null;
                        String command = null;
                        String commandDescription = null;

                        String value = null;
                        int numNodes = 0;
                        java.util.Map nodes = null;
                        java.util.Iterator itNodes = null;

                        List operationsList        = dmDemoBean.genericProcessorTools.getOperationsList();
                        List operationsResultsList = null;
                        int numOfOperations        = operationsList.size();

                        if (dmDemoBean.getSessionState().equals("C") ) {
                            operationsResultsList = dmDemoBean.genericProcessorTools.getOperationsResultsWithValue();
                        }

                        //
                        // The last operation isn't showed beacause is the dummy alert
                        //
                        for (int i=0; i<(numOfOperations - 1); i++) {
                            operation = (ManagementOperation)operationsList.get(i);
                            if (!(operation instanceof TreeManagementOperation)) {
                              continue;
                            }
                            if ( dmDemoBean.getSessionState().equals("C") ) {
                                operationResult = (ManagementOperationResult)operationsResultsList.get(i);
                                nodes = operationResult.getNodes();
                                command = operationResult.getCommand();
                                commandDescription = command;
                            } else {
                                nodes = ((TreeManagementOperation)operation).getNodes();
                                command = operation.getDescription();

                                if (operation instanceof UserAlertManagementOperation) {
                                    int alertCode = ((UserAlertManagementOperation)operation).getAlertCode();
                                    if (alertCode == AlertCode.DISPLAY) {
                                        commandDescription = "Display";
                                    } else if (alertCode == AlertCode.CONFIRM_OR_REJECT) {
                                        commandDescription = "Confirmation";
                                    } else if (alertCode == AlertCode.INPUT) {
                                        commandDescription = "Input";
                                    } else if (alertCode == AlertCode.SINGLE_CHOICE) {
                                        commandDescription = "Choise";
                                    } else {
                                        commandDescription = "Alert";
                                    }
                                } else {
                                    commandDescription = command;
                                }
                            }

                            //
                            // If the operation is a Alert, create a dummy nodes
                            //  hashmap with the alerts values
                            //
                            if (command.equalsIgnoreCase("Alert") ||
                                command.equalsIgnoreCase("Display") ||
                                command.equalsIgnoreCase("Confirmation") ||
                                command.equalsIgnoreCase("Input") ||
                                command.equalsIgnoreCase("Choise")) {

                                String[] alerts = ((UserAlertManagementOperation)operation).getAlerts();
                                nodes = new HashMap();
                                for (int t=0; t<alerts.length; t++) {
                                    nodes.put(alerts[t], alerts[t]);
                                }
                            }
                            numNodes = nodes.size();
                            value    = null;

                            itNodes  = nodes.keySet().iterator();
                        %>
                            <tr>
                                <td><%= commandDescription %></td>
                                <td>
                                    <!-- Nodes URI-->
                                    <table>
                                        <%
                                            while (itNodes.hasNext()) {
                                        %>
                                            <tr>
                                                <td>
                                                    <%
                                                        if (command.equalsIgnoreCase("Alert") ||
                                                            command.equalsIgnoreCase("Display") ||
                                                            command.equalsIgnoreCase("Confirmation") ||
                                                            command.equalsIgnoreCase("Input") ||
                                                            command.equalsIgnoreCase("Choise")
                                                        ) {
                                                            itNodes.next();
                                                    %>
                                                            &nbsp;
                                                    <%
                                                        } else {
                                                    %>
                                                            <%= itNodes.next() %>
                                                    <%
                                                        }
                                                    %>

                                                </td>
                                            </tr>
                                        <%
                                        }
                                        %>
                                    </table>
                                </td>
                                <td>
                                    <%
                                        if (!command.equals("Get")) {
                                    %>
                                            <!-- Values -->
                                            <table>
                                                <%
                                                    itNodes  = nodes.keySet().iterator();
                                                    Object oValue = null;
                                                    while (itNodes.hasNext()) {
                                                        oValue = nodes.get(itNodes.next());

                                                        if (oValue instanceof TreeNode) {
                                                            oValue = ((TreeNode)oValue).getValue();
                                                            if (oValue == null) {
                                                                oValue = "";
                                                            }
                                                        }
                                                %>
                                                    <tr>
                                                        <td><%= oValue %></td>
                                                    </tr>
                                                <%
                                                    }
                                                %>
                                           </table>
                                   <%
                                        }  else {
                                   %>
                                             &nbsp;
                                   <%
                                        }
                                    %>
                                </td>
                                <c:if test="${state == 'NEW'}">
                                        <td><a href="genericSession.jsp?operationId=<%= i%>&deleteOp=true"><img border="0" src="../img/delete.gif" alt="Delete"/></a></td>
                                        <td>
                                          <a href="genericSession.jsp?operationId=<%= i%>&move=up"><img border="0" src="../img/up.gif" alt="Move up"/></a>
                                          <a href="genericSession.jsp?operationId=<%= i%>&move=down"><img border="0" src="../img/down.gif" alt="Move down"/></a>
                                        </td>
                                    </c:if>

                                    <c:if test="${state == 'P'}">
                                        <td><a href="genericSession.jsp?operationId=<%= i%>&deleteOp=true"><img border="0" src="../img/delete.gif" alt="Delete"/></a></td>
                                        <td>
                                          <a href="genericSession.jsp?operationId=<%= i%>&move=up"><img border="0" src="../img/up.gif" alt="Move up"/></a>
                                          <a href="genericSession.jsp?operationId=<%= i%>&move=down"><img border="0" src="../img/down.gif" alt="Move down"/></a>
                                        </td>
                                    </c:if>
                                    <c:if test="${state == 'C'}">
                                        <%
                                            int statusCode = operationResult.getStatusCode();
                                        %>
                                        <td>
                                            <%
                                                if (command.equals("Get")) {
                                            %>
                                                    <table>
                                                        <%
                                                            itNodes  = nodes.keySet().iterator();
                                                            Object result = null;
                                                            while (itNodes.hasNext()) {
                                                                result = nodes.get(itNodes.next());
                                                                if (result instanceof TreeNode) {
                                                                    result = ((TreeNode)result).getValue();
                                                                }
                                                        %>
                                                                <tr>
                                                                    <td><%= result %></td>
                                                                </tr>

                                                        <%
                                                            }
                                                        %>
                                                    </table>
                                           <%
                                                }  else {
                                           %>
                                                     &nbsp;
                                           <%
                                                }
                                            %>
                                        </td>
                                        <td align="center">
                                            <%
                                                if (command.equalsIgnoreCase("Confirmation")) {
                                                    if (statusCode == 200)  {
                                                        out.print("Yes");
                                                    } else if (statusCode == 214) {
                                                        out.print("Cancel");
                                                    } else if (statusCode == 304) {
                                                        out.print("No");
                                                    } else {
                                                        out.print(statusCode);
                                                    }
                                                } else {
                                            %>
                                                    <%= statusCode%>
                                            <%
                                                }
                                            %>
                                        </td>
                                    </c:if>
                            </tr>
                    <%
                        }
                    %>

                </table>
            </td>
        </tr>
    </table>
    </form>

    <script type="javascript">showProp(document, 'parent')</script>

</body>
</html>
