<%--
 Copyright (C) 2003-2005 Funambol
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 --%>

<%-- author: Stefano Nichele @ Funambol --%>
<%-- $Id: login.jsp,v 1.1 2005/05/16 17:00:37 nichele Exp $ --%>

<%@ taglib prefix="sql" uri="/WEB-INF/tlds/sql.tld" %>
<%@ taglib prefix="c" uri="/WEB-INF/tlds/c.tld" %>
<%@ taglib prefix="fmt" uri="/WEB-INF/tlds/fmt.tld" %>

<%@ page errorPage = "ErrorPage.jsp" %>

<%@ page import="java.util.*" %>
<%@ page import="java.sql.*" %>
<%@ page import="javax.sql.*" %>
<%@ page import="sync4j.framework.tools.*" %>
<%@ page import="sync4j.dmdemo.*" %>

<fmt:setLocale value="en_EN" />
<fmt:setBundle basename="DMDemo" />

<jsp:useBean id="dmDemoBean" scope="session" class="sync4j.dmdemo.DMDemoBean"/>

<%
   // Set the datasource in session
   session.setAttribute("dataSource", dmDemoBean.getDataSource());

   String deviceId = request.getParameter("deviceId");
   String password = request.getParameter("password");
   String login    = request.getParameter("login");

   boolean logged  = false;
   if (login != null && login.equalsIgnoreCase("true")) {
       logged = dmDemoBean.loginUser(deviceId, password);
   } else {
       if (dmDemoBean.isUserLogged()) {
           %>
               <jsp:forward page="main.jsp" />
           <%
       }
   }
%>
<c:set var="logged"><%= logged %></c:set>
<c:set var="login"><%= login %></c:set>

<c:if test="${login=='true' && logged=='true'}">
    <jsp:forward page="main.jsp" />
</c:if>

<html>
    <head>
        <title><fmt:message key="WINDOW_TITLE" /></title>
        <link rel="stylesheet" type="text/css" href="../css/style.css">

    </head>

    <body>

        <c:choose>
            <c:when test="${logged == 'false' && login == 'true'}">
                <div align="center" class="loginError"><fmt:message key="LOGIN_FAILED" /></div>
            </c:when>
            <c:otherwise>
                <div align="center" class="loginError">&nbsp;</div>
            </c:otherwise>
        </c:choose>

        <div align="center" >
            <form action="login.jsp" name="loginForm">
                <input type="hidden" name="login" value="true" />

                <table width="1%" border="0" bordercolor="red">

                    <tr>
                        <td nowrap="nowrap"><fmt:message key="DEVICE_ID" />:</td>
                        <td><input type="text" name="deviceId"/></td>
                    </tr>
                    <tr>
                        <td align="center" colspan="2"><input type="submit" name="loginButton" value="<fmt:message key="LOG_IN" />" /></td>
                    </tr>

                </table>
            </form>
        </div>

    </body>

    <script language="javascript" type="text/javascript">
         document.loginForm.deviceId.focus();
    </script>
</html>


