--
-- This script contains the ddl to create the engine database,
--   as created with dbschema from ids921uc42.
--
-- @author Hoyte Swager @ DigiDoc
--
-- @version $Id: create_engine.ddl,v 1.1 2005/05/16 17:32:57 nichele Exp $
--

create table sync4j_principal
  (
    username varchar(32) not null ,
    device   varchar(128) not null ,
    id       varchar(128) not null ,
    primary key (id)  constraint pk_sync4j_principal
  );

create table sync4j_user
  (
    username varchar(32) not null ,
    password varchar(32) not null,
    email varchar(50),
    first_name varchar(255),
    last_name varchar(255),
    internal_user char(1 ) not null default 'N',

    primary key (username)  constraint pk_sync4j_user
  );

create table sync4j_device
  (
    id              varchar(128) not null,
    description     varchar(255),
    type            varchar(255),
    digest          varchar(255),
    client_nonce    varchar(255),
    server_nonce    varchar(255),
    server_password varchar(255),

    primary key (id)  constraint pk_sync4j_device
  );


create table sync4j_id
(
  idspace varchar(30) not null,
  counter int         not null,

  primary key (idspace) constraint pk_sync4j_id
);



create table sync4j_role
(
  role        varchar(128) NOT NULL,
  description varchar(200) not null,

  primary key (role) constraint pk_sync4j_role
);


create table sync4j_user_role
(
  username varchar(32 ) NOT NULL,
  role     varchar(128) NOT NULL,

  primary key (username,role) constraint pk_sync4j_user_role
);


create table sync4j_dm_state
(
    device    varchar(128)           ,
    mssid     varchar(32)            ,
    state     char(1)                ,
    start_ts  datetime year to second,
    end_ts    datetime year to second,
    operation varchar(20)            ,
    info      varchar(1024)          ,
);

create index nxd_dm_state on sync4j_dm_state (device   );
create index nxd_dm_state on sync4j_dm_state (mssid    );
create index nxd_dm_state on sync4j_dm_state (state    );
create index nxd_dm_state on sync4j_dm_state (operation);
create index nxd_dm_state on sync4j_dm_state (info     );


--
-- CONSTRAINTS
--


alter table sync4j_principal add constraint (foreign
    key (username) references sync4j_user  constraint
    fk_user);

alter table sync4j_principal add constraint (foreign
    key (device) references sync4j_device  constraint
    fk_device);

alter table sync4j_dm_state add constraint (foreign
    key (device) references sync4j_device
    constraint fk_device1);
